;####################################################################################################
;#//
;#//  Copyright(C) Renesas Electronics Corp. All rights reserved.
;#//
;#// ================================================================================================
;#//  HARDWARE        : GOSE
;#//  FUNCTIONS       : MiniMonitor  SPI_Boot
;#//  MONITOR VERSION : Ver0.06
;#//  AUTHOR          : Renesas Electronics Corp.
;#//  NOTES           :
;#// ================================================================================================
;#//
;#// ----  THIS FILE  INFORMATION   -----------------------------------------------------------------
;#//  THIS FILE       : boot_mon_spi.s
;#//  FUNCTIONS       : Initial setting of the GOSE board
;#//  MODIFIED        : 2015.11.10
;#//  NOTES           :
;#//     Ver0.01      : NEW
;#//     Ver0.02      : Change DDR initial setting (DBSC3_0_DBADJ2)
;#//     Ver0.03      : Change DDR initial setting (Updates to the hardware manual DBSC3 Rev0.90) etc.
;#//     Ver0.04      : Change DDR initial setting DBCALTR.
;#//     Ver0.05      : Add bootlock error W/A
;#//     Ver0.06      : Change DDR initial setting DBTR9. TECHNICAL UPDATE(TN-RCS-B011A/E).
;#// ------------------------------------------------------------------------------------------------
;#//
;####################################################################################################
	.INCLUDE		"boot_mon_spi.h"
	.ALIGN	4


	.global		GoMain				;#
	.extern		prgStartAd			;#


;#---BOOT_SET---------------------------------------------------------------------------------------
;#.equ 	BOOT_MODE,AREA0_BOOT		;# AREA0_BOOT
.equ 	BOOT_MODE,SPI_BOOT			;# SPI_BOOT
;#--------------------------------------------------------------------------------------------------


;#---DDR_WAIT_SET-----------------------------------------------------------------------------------
;#.equ 	DDR_WAIT,ENABLE				;# ENABLE
.equ 	DDR_WAIT,DISABLE			;# DISABLE
;#--------------------------------------------------------------------------------------------------


;#---CACHE_SET--------------------------------------------------------------------------------------
.equ 	CACHE_MODE,ENABLE			;# ENABLE
;#.equ 	CACHE_MODE,DISABLE			;# DISABLE
;#--------------------------------------------------------------------------------------------------




;####################################################################################################
;# xN^e[u錾
;####################################################################################################
Vector_Table:
	LDR		PC,=Reset_Handler		;# Zbg
	LDR		PC,=Undefined_Handler	;# `
	LDR		PC,=SVC_Handler			;# \tgEFA荞
	LDR		PC,=Prefetch_Handler	;# A{[givtFb`j
	LDR		PC,=Abort_Handler		;# A{[gif[^j
	NOP								;# Reserved vector
	LDR		PC,=IRQ_Handler			;# IRQ
	LDR		PC,=FIQ_Handler			;# FIQ

;####################################################################################################
;# ݃nh
;####################################################################################################
;###### <`>               ##################################################################
Undefined_Handler:
	STMFD	SP!, {R0-R12,LR}		;#WX^vbV
;# vOɏ
	LDMFD	SP!, {R0-R12,PC}^		;#WX^߂O畜Ai^CqCPSRSPSR畜j

;###### <\tgEFA荞>     ##################################################################
SVC_Handler:
	STMFD	SP!, {R0-R12,LR}		;#WX^vbV
;# vOɏ
	LDMFD	SP!, {R0-R12,PC}^		;#WX^߂O畜Ai^CqCPSRSPSR畜j

;###### <A{[givtFb`j> ##################################################################
Prefetch_Handler:
	SUB		R14, R14 , #4			;#LR(R14)-4
	STMFD	SP!, {R0-R12,LR}		;#WX^vbV
;#vOɏ
	LDMFD	SP!, {R0-R12,PC}^		;#WX^߂O畜Ai^CqCPSRSPSR畜j

;###### <A{[gif[^j>       ##################################################################
Abort_Handler:
	SUB		R14,R14,#8				;#LR(R14)-8 ߂AhXO|Cgɖ߂߂̏(OCꍇ)
	STMFD	SP!, {R0-R12,LR}		;#WX^vbV
;#vOɏ
	LDMFD	SP!, {R0-R12,PC}^		;#WX^߂O畜Ai^CqCPSRSPSR畜j

;###### <IRQ>                      ##################################################################
IRQ_Handler:
	SUB		R14, R14 , #4			;#LR(R14)-4
	STMFD	SP!, {R0-R12,LR}		;#OnhɓƂAWX^vbV
;#vOɏ
	LDMFD	SP!, {R0-R12,PC}^		;#WX^߂O畜Ai^CqCPSRSPSR畜j

;###### <FIQ>                      ##################################################################
FIQ_Handler:
	SUB		R14,R14,#4				;#LR-4iR14_fiq)
	STMFD	SP!, {R0-R7,LR}			;#WX^vbV (R0-R7)
;#vOɏ
	LDMFD	SP!, {R0-R7,PC}^		;#WX^߂O畜Ai^CqCPSRSPSR畜j

;####################################################################################################
;####################################################################################################
;######
;######        Zbgnh
;######
;####################################################################################################
;####################################################################################################
Reset_Handler:
;##### WX^ ###############################################################################
Register_init:
	LDR		R0, =0					;# R0
	LDR		R1, =0					;# R1
	LDR		R2, =0					;# R2
	LDR		R3, =0					;# R3
	LDR		R4, =0					;# R4
	LDR		R5, =0					;# R5
	LDR		R6, =0					;# R6
	LDR		R7, =0					;# R7
	LDR		R8, =0					;# R8
	LDR		R9, =0					;# R9
	LDR		R10, =0					;# R10
	LDR		R11, =0					;# R11
	LDR		R12, =0					;# R12
	LDR		R13, =0					;# R13(SP)
	LDR		R14, =0					;# R14(LR)
;#	LDR		R15, =0					;# R15(PC)͏Ȃ

;##### X^bN|C^ #######################################################################
;# dON̓X[p[oCU[hŋN (CPSR l =H'01D3)
Stack_init:
;#--------------------------------------------------------------------------------------------------
Stack_init_irq:	;# IRQ[hɐݒ,SPݒ
	MRS		R1, CPSR
	BIC		R1, R1, #0x1F
;#	BIC		R1, R1, #0xDF			;#݃}XN (bit7(IRQ),6(FIQ):0NA)
	ORR		R1, R1, #PSR_MODE_IRQ
	MSR		CPSR_c, R1
;# SPݒ
	LDR		R0, =STACK_IRQ_ADR		;#X^bN|C^AhX
	MOV		SP, R0

;#--------------------------------------------------------------------------------------------------
Stack_init_frq:	;# FIQ[hɐݒ,SPݒ
	MRS		R1, CPSR
	BIC		R1, R1, #0x1F
;#	BIC		R1, R1, #0xDF			;#݃}XN (bit7(IRQ),6(FIQ):0NA)
	ORR		R1, R1, #PSR_MODE_FIQ
	MSR		CPSR_c, R1
;# SPݒ
	LDR		R0, =STACK_FIQ_ADR		;#X^bN|C^AhX
	MOV		SP, R0

;#--------------------------------------------------------------------------------------------------
Stack_init_abt:	;# ABT[hɐݒ,SPݒ
	MRS		R1, CPSR
	BIC		R1, R1, #0x1F
;#	BIC		R1, R1, #0xDF			;#݃}XN (bit7(IRQ),6(FIQ):0NA)
	ORR		R1, R1, #PSR_MODE_ABT
	MSR		CPSR_c, R1
;# SPݒ
	LDR		R0, =STACK_ABT_ADR		;#X^bN|C^AhX
	MOV		SP, R0

;#-ǉ---------------------------------------------------------------------------------------------
Stack_init_svc:	;# SVC[hɐݒ,SPݒ
	MRS		R1, CPSR
	BIC		R1, R1, #0x1F
;#	BIC		R1, R1, #0xDF			;#݃}XN (bit7(IRQ),6(FIQ):0NA)
	ORR		R1, R1, #PSR_MODE_SVC
	MSR		CPSR_c, R1
;# SPݒ
	LDR		R0, =STACK_SVC_ADR		;#X^bN|C^AhX
	MOV		SP, R0

;#-ǉ---------------------------------------------------------------------------------------------
Stack_init_und:	;# UND[hɐݒ,SPݒ
	MRS		R1, CPSR
	BIC		R1, R1, #0x1F
;#	BIC		R1, R1, #0xDF			;#݃}XN (bit7(IRQ),6(FIQ):0NA)
	ORR		R1, R1, #PSR_MODE_UND
	MSR		CPSR_c, R1
;# SPݒ
	LDR		R0, =STACK_UND_ADR		;#X^bN|C^AhX
	MOV		SP, R0

;#--------------------------------------------------------------------------------------------------
Stack_init_sys:	;# VXe[hɐݒ,SPݒ
	MRS		R1, CPSR
	BIC		R1, R1, #0x1F
;#	BIC		R1, R1, #0xDF			;#݃}XN (bit7(IRQ),6(FIQ):0NA)
	ORR		R1, R1, #PSR_MODE_SYS
	MSR		CPSR_c, R1
;# SPݒ
	LDR		R0, =STACK_SYS_ADR		;#X^bN|C^AhX
	MOV		SP, R0


;####################################################################################################
;#
;#  {[h
;#
;####################################################################################################

;####################################################################################################
;####		RWDT,secureWDT setting (Timer Disable setting)
;####################################################################################################
Init_set_WDT:
	LDR		R0,	=RWDT_RWTCSRA
	LDR		R1, =0xA5A5A500				;#Timer disabled
	STR		R1, [R0]

Init_set_SECWDT:
	LDR		R0,	=SECWDT_WTCSRA
	LDR		R1, =0xA5A5A500				;#Timer  disabled (Enable -> disabled)
	STR		R1, [R0]


.IF CACHE_MODE == ENABLE
;####################################################################################################
;#####		Z:\AI:߃LbVLɐݒ
;####################################################################################################
;#invalidate (\p)
  MCR     p15, 0, r0, c7, c5, 0   ;# ICIALLU :Invalidate all instruction caches to PoU
  MCR     p15, 0, r0, c7, c5, 6   ;# BPIALL  :Invalidate all branch predictors

;#Init_enable_Cache:  CP15  WX^P(C1)F䃌WX^
  MRC     p15, 0, r0, c1, c0, 0   ;# Read CP15 REG1(C1) data
  ORR     r0, r0, #(1 << 11)      ;# bit11:Z bit Set  (\          1:  0:֎~)
  ORR     r0, r0, #(1 << 12)      ;# bit12:I bit Set  (߃LbV    1:  0:֎~)
  MCR     p15, 0, r0, c1, c0, 0   ;# Write CP15 REG1(C1)data
  ISB                             ;# ߓ
.ENDIF


;####################################################################################################
;####		PFC setting
;####################################################################################################
Init_set_PFC:

;# R0:Write Regster
;# R1:Write Data
;# R2:Write Data(Inverted data)
;# R3:PFC_PMMR

	LDR		R3,	=PFC_PMMR

;#-- MOD_SEL set ------------------------------------------------------------------------------------
Init_set_PFC_MOD_SEL:
	LDR		R1, =0x60000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_MOD_SEL
	STR		R1, [R0]

;#-- MOD_SEL2 set -----------------------------------------------------------------------------------
Init_set_PFC_MOD_SEL2:
	LDR		R1, =0x60000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_MOD_SEL2
	STR		R1, [R0]

;#-- MOD_SEL3 set -----------------------------------------------------------------------------------
Init_set_PFC_MOD_SEL3:
	LDR		R1, =0x00800200
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_MOD_SEL3
	STR		R1, [R0]

;#-- MOD_SEL4 set -----------------------------------------------------------------------------------
Init_set_PFC_MOD_SEL4:
	LDR		R1, =0x00000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_MOD_SEL4
	STR		R1, [R0]

;#-- IPSR set  --------------------------------------------------------------------------------------
;#-- IPSR0 set --------------------------------------------------------------------------------------
Init_set_PFC_IPSR0:
	LDR		R1, =0x00000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR0
	STR		R1, [R0]

;#-- IPSR1 set --------------------------------------------------------------------------------------
Init_set_PFC_IPSR1:
	LDR		R1, =0x00000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR1
	STR		R1, [R0]

;#-- IPSR2 set --------------------------------------------------------------------------------------
Init_set_PFC_IPSR2:

.IF BOOT_MODE == AREA0_BOOT
	LDR		R1, =0x00000000
.ENDIF

.IF BOOT_MODE == SPI_BOOT
	LDR		R1, =0x000244C8
.ENDIF

	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR2
	STR		R1, [R0]

;#-- IPSR3 set --------------------------------------------------------------------------------------
Init_set_PFC_IPSR3:
	LDR		R1, =0x00000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR3
	STR		R1, [R0]

;#-- IPSR4 set --------------------------------------------------------------------------------------
Init_set_PFC_IPSR4:
	LDR		R1, =0x00002400
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR4
	STR		R1, [R0]

;#-- IPSR5 set --------------------------------------------------------------------------------------
Init_set_PFC_IPSR5:
	LDR		R1, =0x01520000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR5
	STR		R1, [R0]

;#-- IPSR6 set --------------------------------------------------------------------------------------
Init_set_PFC_IPSR6:
	LDR		R1, =0x00724003
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR6
	STR		R1, [R0]

;#-- IPSR7 set --------------------------------------------------------------------------------------
Init_set_PFC_IPSR7:
	LDR		R1, =0x00000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR7
	STR		R1, [R0]

;#-- IPSR8 set --------------------------------------------------------------------------------------
Init_set_PFC_IPSR8:
	LDR		R1, =0x00000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR8
	STR		R1, [R0]

;#-- IPSR9 set --------------------------------------------------------------------------------------
Init_set_PFC_IPSR9:
	LDR		R1, =0x00000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR9
	STR		R1, [R0]

;#-- IPSR10 set -------------------------------------------------------------------------------------
Init_set_PFC_IPSR10:
	LDR		R1, =0x00000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR10
	STR		R1, [R0]

;#-- IPSR11 set -------------------------------------------------------------------------------------
Init_set_PFC_IPSR11:
	LDR		R1, =0x00000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR11
	STR		R1, [R0]

;#-- IPSR12 set -------------------------------------------------------------------------------------
Init_set_PFC_IPSR12:
	LDR		R1, =0x00000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR12
	STR		R1, [R0]

;#-- IPSR13 set -------------------------------------------------------------------------------------
Init_set_PFC_IPSR13:
	LDR		R1, =0x00000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR13
	STR		R1, [R0]

;#-- IPSR14 set -------------------------------------------------------------------------------------
Init_set_PFC_IPSR14:
	LDR		R1, =0x00000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR14
	STR		R1, [R0]

;#-- IPSR15 set -------------------------------------------------------------------------------------
Init_set_PFC_IPSR15:
	LDR		R1, =0x00000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR15
	STR		R1, [R0]

;#-- IPSR16 set -------------------------------------------------------------------------------------
Init_set_PFC_IPSR16:
	LDR		R1, =0x00000000
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_IPSR16
	STR		R1, [R0]


;#-- GPSR set  --------------------------------------------------------------------------------------
;#-- GPSR0 set --------------------------------------------------------------------------------------
Init_set_PFC_GPSR0:
	LDR		R1, =0xFFFFFFFF
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_GPSR0
	STR		R1, [R0]

;#-- GPSR1 set --------------------------------------------------------------------------------------
Init_set_PFC_GPSR1:
	LDR		R1, =0x00EC3FFF
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_GPSR1
	STR		R1, [R0]

;#-- GPSR2 set --------------------------------------------------------------------------------------
Init_set_PFC_GPSR2:
	LDR		R1, =0x3BC001E7
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_GPSR2
	STR		R1, [R0]

;#-- GPSR3 set --------------------------------------------------------------------------------------
Init_set_PFC_GPSR3:
	LDR		R1, =0x5BFFFFFF
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_GPSR3
	STR		R1, [R0]

;#-- GPSR4 set --------------------------------------------------------------------------------------
Init_set_PFC_GPSR4:
	LDR		R1, =0x1FFFFFFB
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_GPSR4
	STR		R1, [R0]

;#-- GPSR5 set --------------------------------------------------------------------------------------
Init_set_PFC_GPSR5:
	LDR		R1, =0x01BFFFF0
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_GPSR5
	STR		R1, [R0]

;#-- GPSR6 set --------------------------------------------------------------------------------------
Init_set_PFC_GPSR6:
	LDR		R1, =0xCF7FFFFF
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_GPSR6
	STR		R1, [R0]

;#-- GPSR7 set --------------------------------------------------------------------------------------
Init_set_PFC_GPSR7:
	LDR		R1, =0x0381FC00
	MVN		R2, R1
	STR		R2, [R3]
	LDR		R0,	=PFC_GPSR7
	STR		R1, [R0]


;#-- PUPCTL set  ------------------------------------------------------------------------------------
;#-- PUPCTL0 set ------------------------------------------------------------------------------------
Init_set_PFC_PUPCTL0:
	LDR		R0,	=PFC_PUPR0

.IF BOOT_MODE == AREA0_BOOT
	LDR		R1, =0x00000000		;# Area0_boot
.ENDIF

.IF BOOT_MODE == SPI_BOOT
	LDR		R1, =0xFFFFFFDF		;# QSPI_boot
.ENDIF

	STR		R1, [R0]

;#-- PUPCTL1 set ------------------------------------------------------------------------------------
Init_set_PFC_PUPCTL1:
	LDR		R0,	=PFC_PUPR1

.IF BOOT_MODE == AREA0_BOOT
	LDR		R1, =0xC8838000		;# Area0_boot
.ENDIF

.IF BOOT_MODE == SPI_BOOT
	LDR		R1, =0xC883C3FF		;# QSPI_boot
.ENDIF

	STR		R1, [R0]


;#-- PUPCTL2 set ------------------------------------------------------------------------------------
Init_set_PFC_PUPCTL2:
	LDR		R0,	=PFC_PUPR2
	LDR		R1, =0x1201F3C9
	STR		R1, [R0]

;#-- PUPCTL3 set ------------------------------------------------------------------------------------
Init_set_PFC_PUPCTL3:
	LDR		R0,	=PFC_PUPR3
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- PUPCTL4 set ------------------------------------------------------------------------------------
Init_set_PFC_PUPCTL4:
	LDR		R0,	=PFC_PUPR4
	LDR		R1, =0xFFFFEB04
	STR		R1, [R0]

;#-- PUPCTL5 set ------------------------------------------------------------------------------------
Init_set_PFC_PUPCTL5:
	LDR		R0,	=PFC_PUPR5
	LDR		R1, =0xC003FFFF
	STR		R1, [R0]

;#-- PUPCTL6 set ------------------------------------------------------------------------------------
Init_set_PFC_PUPCTL6:
	LDR		R0,	=PFC_PUPR6
	LDR		R1, =0x0800000F
	STR		R1, [R0]

;#-- PUPCTL7 set ------------------------------------------------------------------------------------
Init_set_PFC_PUPCTL7:
	LDR		R0,	=PFC_PUPR7

.IF BOOT_MODE == AREA0_BOOT
	LDR		R1, =0x000800F0		;# Area0_boot	Enable:ASEBRK_N_ACK is pulled down (bit19)
.ENDIF

.IF BOOT_MODE == SPI_BOOT
	LDR		R1, =0x001800F0		;# QSPI_boot	Enable:ASEBRK_N_ACK is pulled down (bit19)
.ENDIF

	STR		R1, [R0]



;####		 end PFC setting		#################################################################


;####################################################################################################
;####		output GPIO setting
;####################################################################################################
Init_set_GPIO:
;#-- POSNEGx set  --(POG or NEG) --------------------------------------------------------------------
;#-- POSNEG1  ---------------------------------------------------------------------------------------
Init_set_GPIO_POSNEG1:
	LDR		R0,	=GPIO_POSNEG1
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- POSNEG2  ---------------------------------------------------------------------------------------
Init_set_GPIO_POSNEG2:
	LDR		R0,	=GPIO_POSNEG2
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- POSNEG3  ---------------------------------------------------------------------------------------
Init_set_GPIO_POSNEG3:
	LDR		R0,	=GPIO_POSNEG3
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- POSNEG4  ---------------------------------------------------------------------------------------
Init_set_GPIO_POSNEG4:
	LDR		R0,	=GPIO_POSNEG4
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- POSNEG5  ---------------------------------------------------------------------------------------
Init_set_GPIO_POSNEG5:
	LDR		R0,	=GPIO_POSNEG5
	LDR		R1, =0x00000000
	STR		R1, [R0]
;#---------------------------------------------------------------------------------------------------

;#-- POSNEG6  ---------------------------------------------------------------------------------------
Init_set_GPIO_POSNEG6:
	LDR		R0,	=GPIO_POSNEG6
	LDR		R1, =0x00000000
	STR		R1, [R0]
;#---------------------------------------------------------------------------------------------------

;#-- POSNEG7  ---------------------------------------------------------------------------------------
Init_set_GPIO_POSNEG7:
	LDR		R0,	=GPIO_POSNEG7
	LDR		R1, =0x00000000
	STR		R1, [R0]
;#---------------------------------------------------------------------------------------------------


;#-- IOINTSELxset --(IN/OUT or INTER)----------------------------------------------------------------
;#-- IOINTSEL1  -------------------------------------------------------------------------------------
Init_set_GPIO_IOINTSEL1:
	LDR		R0,	=GPIO_IOINTSEL1
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- IOINTSEL2  -------------------------------------------------------------------------------------
Init_set_GPIO_IOINTSEL2:
	LDR		R0,	=GPIO_IOINTSEL2
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- IOINTSEL3  -------------------------------------------------------------------------------------
Init_set_GPIO_IOINTSEL3:
	LDR		R0,	=GPIO_IOINTSEL3
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- IOINTSEL4  -------------------------------------------------------------------------------------
Init_set_GPIO_IOINTSEL4:
	LDR		R0,	=GPIO_IOINTSEL4
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- IOINTSEL5  -------------------------------------------------------------------------------------
Init_set_GPIO_IOINTSEL5:
	LDR		R0,	=GPIO_IOINTSEL5
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- IOINTSEL6  -------------------------------------------------------------------------------------
Init_set_GPIO_IOINTSEL6:
	LDR		R0,	=GPIO_IOINTSEL6
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- IOINTSEL7  -------------------------------------------------------------------------------------
Init_set_GPIO_IOINTSEL7:
	LDR		R0,	=GPIO_IOINTSEL7
	LDR		R1, =0x00000000
	STR		R1, [R0]
;#---------------------------------------------------------------------------------------------------

;#-- OUTDTxset --------------------------------------------------------------------------------------
;#-- OUTDT2  ----------------------------------------------------------------------------------------
Init_set_GPIO_OUTDT2:
	LDR		R0,	=GPIO_OUTDT2
	LDR		R1, =0x04381000

	STR		R1, [R0]

;#-- OUTDT5  ----------------------------------------------------------------------------------------
Init_set_GPIO_OUTDT5:
	LDR		R0,	=GPIO_OUTDT5
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- OUTDT7  ----------------------------------------------------------------------------------------
Init_set_GPIO_OUTDT7:
	LDR		R0,	=GPIO_OUTDT7
	LDR		R1, =0x000E0000
	STR		R1, [R0]
;#---------------------------------------------------------------------------------------------------


;#-- INOUTSELxset --(IN or OUT)----------------------------------------------------------------------
;#-- INOUTSEL1  -------------------------------------------------------------------------------------
Init_set_GPIO_INOUTSEL1:
	LDR		R0,	=GPIO_INOUTSEL1
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- INOUTSEL2  -------------------------------------------------------------------------------------
Init_set_GPIO_INOUTSEL2:
	LDR		R0,	=GPIO_INOUTSEL2
	LDR		R1, =0x04381010

	STR		R1, [R0]

;#-- INOUTSEL3  -------------------------------------------------------------------------------------
Init_set_GPIO_INOUTSEL3:
	LDR		R0,	=GPIO_INOUTSEL3
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- INOUTSEL4  -------------------------------------------------------------------------------------
Init_set_GPIO_INOUTSEL4:
	LDR		R0,	=GPIO_INOUTSEL4
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- INOUTSEL5  -------------------------------------------------------------------------------------
Init_set_GPIO_INOUTSEL5:
	LDR		R0,	=GPIO_INOUTSEL5
	LDR		R1, =0x00400000
	STR		R1, [R0]

;#-- INOUTSEL6  -------------------------------------------------------------------------------------
Init_set_GPIO_INOUTSEL6:
	LDR		R0,	=GPIO_INOUTSEL6
	LDR		R1, =0x00000000
	STR		R1, [R0]

;#-- INOUTSEL7  -------------------------------------------------------------------------------------
Init_set_GPIO_INOUTSEL7:
	LDR		R0,	=GPIO_INOUTSEL7
	LDR		R1, =0x000E0380
	STR		R1, [R0]

;#---------------------------------------------------------------------------------------------------


;####		end Output GPIO  setting	#############################################################



;####################################################################################################
;####		CPG , RST_WDt setting  (Module Reset setting)
;####################################################################################################
Init_set_CPG:

;####		end CPG setting		#####################################################################



;####################################################################################################
;#####	LBSC setting
;####################################################################################################
Init_set_LBSC:
Init_set_LBSC_CS:
	LDR		R0,	=LBSC_CS0CTRL
	LDR		R1, =0x00000020				;# CS0: I/F=SRAM
	STR		R1, [R0]

	LDR		R0,	=LBSC_CS1CTRL
	LDR		R1, =0x00000020				;# CS1: width=16bit , I/F=SRAM
	STR		R1, [R0]

	LDR		R0,	=LBSC_ECS0CTRL
	LDR		R1, =0x00002020				;# EXCS0: CP=32MB , width=16bit , I/F=SRAM
	STR		R1, [R0]

	LDR		R0,	=LBSC_ECS1CTRL
	LDR		R1, =0x00002020				;# EXCS1: CP=32MB , width=16bit , I/F=SRAM
	STR		R1, [R0]

;#---------------------------------------------------------------------------------------------------
Init_set_LBSC_CSWCR:
	LDR		R0,	=LBSC_CSWCR0
	LDR		R1, =0x2A103320				;# WRPulse=5, WRS=2,WRH=1 / RDPulse=6, RDS=3,RDH=2
	STR		R1, [R0]

	LDR		R0,	=LBSC_CSWCR1
	LDR		R1, =0x2A103320				;# WRPulse=5, WRS=2,WRH=1 / RDPulse=6, RDS=3,RDH=2
	STR		R1, [R0]

	LDR		R0,	=LBSC_ECSWCR0
	LDR		R1, =0xFF70FF70				;# WRPulse=31,WRS=7,WRH=7 / RDPulse=31,RDS=7,RDH=7  (initial value)
	STR		R1, [R0]

	LDR		R0,	=LBSC_ECSWCR1
	LDR		R1, =0xFF70FF70				;# WRPulse=31,WRS=7,WRH=7 / RDPulse=31,RDS=7,RDH=7  (initial value)
	STR		R1, [R0]

;#---------------------------------------------------------------------------------------------------
Init_set_LBSC_CSPWCR:
	LDR		R0,	=LBSC_CSPWCR0
	LDR		R1, =0x00000000				;# Wait_set:Disable (initial value)
	STR		R1, [R0]

	LDR		R0,	=LBSC_CSPWCR1
	LDR		R1, =0x00000000				;# Wait_set:Disable (initial value)
	STR		R1, [R0]

	LDR		R0,	=LBSC_ECSPWCR0
	LDR		R1, =0x00000000				;# Wait_set:Disable (initial value)
	STR		R1, [R0]

	LDR		R0,	=LBSC_ECSPWCR1
	LDR		R1, =0x00000000				;# Wait_set:Disable (initial value)
	STR		R1, [R0]

	LDR		R0,	=LBSC_EXWTSYNC
	LDR		R1, =0x00000000				;# Wait_set:Disable (initial value)
	STR		R1, [R0]

;#---------------------------------------------------------------------------------------------------
Init_set_LBSC_CSGDST:
	LDR		R0,	=LBSC_CS1GDST
	LDR		R1, =0x00000000				;# Timer_set:Disable (initial value)
	STR		R1, [R0]

	LDR		R0,	=LBSC_ECS0GDST
	LDR		R1, =0x00000000				;# Timer_set:Disable (initial value)
	STR		R1, [R0]

	LDR		R0,	=LBSC_ECS1GDST
	LDR		R1, =0x00000000				;# Timer_set:Disable (initial value)
	STR		R1, [R0]

	LDR		R0,	=LBSC_ATACSCTRL
	LDR		R1, =0x00000000				;# ATACS:Disable (initial value)
	STR		R1, [R0]

;####		end LBSC setting	#####################################################################



.IF DDR_WAIT == ENABLE

;####################################################################################################
;#####		DDR Setting
;####################################################################################################

Init_set_DDR:
Init_set_DDR_wait00:
	LDR		R0, =100000

Init_set_DDR_wait00_loop:
	SUBS	R0,R0,#1
	BNE		Init_set_DDR_wait00_loop

.ENDIF



;# --------------------------------------------------------------------------------------------------
;####		START DDR1600(800MHz) setting	#########################################################
;# --------------------------------------------------------------------------------------------------


;#(1)-2.After release from the reset state, set the registers as follows:
;#(1)-2-1 Write Hf0000A55A to the PHY unit lock register (DBPDLCK).
Init_DDR1600_1_2_1:
	LDR		R0,	=DBSC3_0_DBPDLCK
	LDR		R1, =0x0000A55A
	STR		R1, [R0]

;# ########### Work around for bootlock error #############################################
;# Ver0.05
;#
	LDR		R0,	=DBSC3_0_DBRSTLCK
	LDR		R1, =0x0000A55A
	STR		R1, [R0]

	LDR		R0,	=DBSC3_0_DBRST
	LDR		R1, =0x00000001
	STR		R1, [R0]
;# ########################################################################################

Init_DDR1600:
;#(1)	(a)After power is turned on, apply a power-on reset and wait until the DBSC3 is released from the reset state.
;#(1)-1.Here, the setting on the M0/1RESET# signals should be executed (The following 3 lines correspond to this setting):
;#(1)-1-1EWrite Hf21000000 to the manual command-issuing register (DBCMD).
Init_DDR1600_1_1_1:
	LDR		R0,	=DBSC3_0_DBCMD
	LDR		R1, =0x21000000		;# opc=RstH(RESET => H)
	STR		R1, [R0]

;#(1)-1-2EWrite Hf11000000 to the manual command-issuing register (DBCMD).
Init_DDR1600_1_1_2:
	LDR		R0,	=DBSC3_0_DBCMD
	LDR		R1, =0x11000000		;# opc==PDXt(CKE=H)
	STR		R1, [R0]

;#(1)-1-3EWrite Hf10000000 to the manual command-issuing register (DBCMD).
Init_DDR1600_1_1_3:
	LDR		R0,	=DBSC3_0_DBCMD
	LDR		R1, =0x10000000		;# opc=PDEn(CKE=L)
	STR		R1, [R0]


Init_DDR1600_5_1:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000001
	STR		R1, [R0]
Init_DDR1600_5_2:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x80000000
	STR		R1, [R0]

Init_DDR1600_5_3:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000004
	STR		R1, [R0]
Init_DDR1600_5_4_0:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1,	[R0]			;# R1 = Read Data
	TST		R1,	#0x00000001		;# Bit0"0"ǂ̔  [ R1 & H'1 -> 0̏ꍇ:Zeroflag=1 , 1̏ꍇ:Zeroflag=0 ]
	BEQ		Init_DDR1600_5_4_0	;# Bit0"0"(Z=1)̏ꍇ[v    [ BEQ [Z=1̎]   ,BNE [Z=0̎] ]


Init_DDR1600_3_3:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000006
	STR		R1, [R0]
Init_DDR1600_3_4:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x0001C000
	STR		R1, [R0]


;# Add Ver0.03  2014.10.01
;# ------------------------
Init_DDR1600_3_4_ADD1:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x0000000F
	STR		R1, [R0]
Init_DDR1600_3_4_ADD2:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x00181224
	STR		R1, [R0]
;# ------------------------


;#(5)-5.	Write Hf00000010 to the PHY unit address register (DBPDRGA).
Init_DDR1600_5_5:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000010
	STR		R1, [R0]


;#(5)-6.	Write HfF004649B to the PHY unit access register (DBPDRGD).
Init_DDR1600_5_6:
	LDR		R0,	=DBSC3_0_DBPDRGD
;#	LDR		R1, =0xF00464DB
	LDR		R1, =0xF004649B			;#Change Ver0.03  2014.10.01
	STR		R1, [R0]


Init_DDR1600_ADD_010_1:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000061
	STR		R1, [R0]


Init_DDR1600_ADD_010_2:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x0000006D
	STR		R1, [R0]


Init_DDR1600_ADD_011_1:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000001
	STR		R1, [R0]
Init_DDR1600_ADD_011_2:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x00000073
	STR		R1, [R0]


;#(2)  (b)DBSC3 Setting 1-----------------------------------------------------------------------------
;#(2)-1	ESDRAMސݒ背WX^iDBKINDj
Init_DDR1600_2_1:
	LDR		R0,	=DBSC3_0_DBKIND
	LDR		R1, =0x00000007		;# bit[2:0]=b'111 DDR3-SDRAM
	STR		R1, [R0]

;#(2)-2	ESDRAM\ݒ背WX^0iDBCONF0j
Init_DDR1600_2_2:
	LDR		R0,	=DBSC3_0_DBCONF0
	LDR		R1, =0x0F030A02		;# RowAd=15,Bank=8,CoulumAd=10
	STR		R1, [R0]

Init_DDR1600_2_3:
;#(2)-3	EPHYސݒ背WX^(DBPHYTYPE)
	LDR		R0,	=DBSC3_0_DBPHYTYPE
	LDR		R1, =0x00000001		;# bit[1:0]=b'01 DFI
	STR		R1, [R0]

;#(2)-4	ESDRAMݒ背WX^(DBBL)
Init_DDR1600_2_4:
	LDR		R0,	=DBSC3_0_DBBL
	LDR		R1, =0x00000000		;# bit[1:0]=b'00 BL=8
	STR		R1, [R0]

;#(2)-5-@ESDRAM^C~OWX^0 iDBTR0j
Init_DDR1600_2_5_1:
	LDR		R0,	=DBSC3_0_DBTR0
	LDR		R1, =0x0000000B		;# CL=11
	STR		R1, [R0]

;#(2)-5-AESDRAM^C~OWX^1 iDBTR1j
Init_DDR1600_2_5_2:
	LDR		R0,	=DBSC3_0_DBTR1
	LDR		R1, =0x00000008		;# CWL=8
	STR		R1, [R0]

;#(2)-5-BESDRAM^C~OWX^2 iDBTR2j
Init_DDR1600_2_5_3:
	LDR		R0,	=DBSC3_0_DBTR2
	LDR		R1, =0x00000000		;# AL=0
	STR		R1, [R0]

;#(2)-5-CESDRAM^C~OWX^3 iDBTR3j
Init_DDR1600_2_5_4:
	LDR		R0,	=DBSC3_0_DBTR3
	LDR		R1, =0x0000000B		;# TRCD=11
	STR		R1, [R0]

;#(2)-5-DESDRAM^C~OWX^4 iDBTR4j
Init_DDR1600_2_5_5:
	LDR		R0,	=DBSC3_0_DBTR4
	LDR		R1, =0x000C000B		;# TRPA=12,TRP=11
	STR		R1, [R0]

;#(2)-5-EESDRAM^C~OWX^5 iDBTR5j
Init_DDR1600_2_5_6:
	LDR		R0,	=DBSC3_0_DBTR5
	LDR		R1, =0x00000027		;# TRC=39
	STR		R1, [R0]

;#(2)-5-FESDRAM^C~OWX^6 iDBTR6j
Init_DDR1600_2_5_7:
	LDR		R0,	=DBSC3_0_DBTR6
	LDR		R1, =0x0000001C		;# TRAS=28
	STR		R1, [R0]

;#(2)-5-GESDRAM^C~OWX^7 iDBTR7j
Init_DDR1600_2_5_8:
	LDR		R0,	=DBSC3_0_DBTR7
	LDR		R1, =0x00000006		;# TRRD=6
	STR		R1, [R0]

;#(2)-5-HESDRAM^C~OWX^8 iDBTR8j
Init_DDR1600_2_5_9:
	LDR		R0,	=DBSC3_0_DBTR8
	LDR		R1, =0x00000020		;# TFAW=32
	STR		R1, [R0]

;#(2)-5-IESDRAM^C~OWX^9 iDBTR9j
Init_DDR1600_2_5_10:
	LDR		R0,	=DBSC3_0_DBTR9
	LDR		R1, =0x00000006		;# TRDPR=8->6 Change Ver0.06 2015.11.10
	STR		R1, [R0]

;#(2)-5-JESDRAM^C~OWX^10iDBTR10j
Init_DDR1600_2_5_11:
	LDR		R0,	=DBSC3_0_DBTR10
	LDR		R1, =0x0000000C		;# TWR=12
	STR		R1, [R0]

;#(2)-5-KESDRAM^C~OWX^11iDBTR11j
Init_DDR1600_2_5_12:
	LDR		R0,	=DBSC3_0_DBTR11
	LDR		R1, =0x00000009		;#
	STR		R1, [R0]

;#(2)-5-LESDRAM^C~OWX^12iDBTR12j
Init_DDR1600_2_5_13:
	LDR		R0,	=DBSC3_0_DBTR12
	LDR		R1, =0x00000012		;#
	STR		R1, [R0]

;#(2)-5-MESDRAM^C~OWX^13iDBTR13j
Init_DDR1600_2_5_14:
	LDR		R0,	=DBSC3_0_DBTR13
	LDR		R1, =0x000000D0		;# TRFC=208
	STR		R1, [R0]

;#(2)-5-NESDRAM^C~OWX^14iDBTR14j
Init_DDR1600_2_5_15:
	LDR		R0,	=DBSC3_0_DBTR14
	LDR		R1, =0x00140005		;# TCKEH DLL=20   TCKEH=5
	STR		R1, [R0]

;#(2)-5-OESDRAM^C~OWX^15iDBTR15j
Init_DDR1600_2_5_16:
	LDR		R0,	=DBSC3_0_DBTR15
	LDR		R1, =0x00050004		;# TCKESR=5  TCKEL=4
	STR		R1, [R0]

;#(2)-5-PESDRAM^C~OWX^16iDBTR16j
Init_DDR1600_2_5_17:
	LDR		R0,	=DBSC3_0_DBTR16
	LDR		R1, =0x70233005		;#
	STR		R1, [R0]

;#(2)-5-QESDRAM^C~OWX^17iDBTR17j
Init_DDR1600_2_5_18:
	LDR		R0,	=DBSC3_0_DBTR17
	LDR		R1, =0x000C0000		;# TMOD=12
	STR		R1, [R0]

;#(2)-5-RESDRAM^C~OWX^18iDBTR18j
Init_DDR1600_2_5_19:
	LDR		R0,	=DBSC3_0_DBTR18
	LDR		R1, =0x00000200
	STR		R1, [R0]

;#(2)-5-SESDRAM^C~OWX^19iDBTR19j
Init_DDR1600_2_5_20:
	LDR		R0,	=DBSC3_0_DBTR19
	LDR		R1, =0x00000040		;# TZQCS 64
	STR		R1, [R0]

;#(2)-6	EODTݒ背WX^0 (DBRNK0)
Init_DDR1600_2_6:
	LDR		R0,	=DBSC3_0_DBRNK0
	LDR		R1, =0x00000001		;# ODT Output Level (Read=0 Low  Write=1 High)
	STR		R1, [R0]

;#(2)-7]@EDBSC쒲WX^0(DBADJ0)
Init_DDR1600_2_7_1:
	LDR		R0,	=DBSC3_0_DBADJ0
	LDR		R1, =0x00020001		;#
	STR		R1, [R0]

;#(2)-7]AEDBSC쒲WX^2(DBADJ2)
Init_DDR1600_2_7_2:
	LDR		R0,	=DBSC3_0_DBADJ2
	LDR		R1, =0x20042004
	STR		R1, [R0]

;#(2)-8]@EAXI|[g0ݒ背WX^0(DBWT0CNF0)
Init_DDR1600_2_8_1:
	LDR		R0,	=DBSC3_0_DBWT0CNF0
	LDR		R1, =0x00020002		;#
	STR		R1, [R0]


;#(2)-8]AEAXI|[g0ݒ背WX^4(DBWT0CNF4)
Init_DDR1600_2_8_2:
	LDR		R0,	=DBSC3_0_DBWT0CNF4
	LDR		R1, =0x0000001F
	STR		R1, [R0]


;#(3)  (c)	PHY Setting 1---------------------------------------------------------------------------
;#(3)-(1)	DBDFISTAT̃WX^readINITCOMPL (bit0)Ɂh1hread邱ƂmF܂Bg1hread鎞ԂɂȂRESET#[qLowɂȂ܂B
;#Init_DDR1600_3_1:
Init_DDR1600_3_1_0:
	LDR		R0,	=DBSC3_0_DBDFISTAT
	LDR		R1,	[R0]			;# R1 = Read Data
	TST		R1,	#0x00000001		;# Bit0"0"ǂ̔  [ R1 & H'1 -> 0̏ꍇ:Zeroflag=1 , 1̏ꍇ:Zeroflag=0 ]
	BEQ		Init_DDR1600_3_1_0	;# Bit0"0"(Z=1)̏ꍇ[v    [ BEQ [Z=1̎]   ,BNE [Z=0̎] ]


Init_DDR1600_3_2:
	LDR		R0,	=DBSC3_0_DBDFICNT
	LDR		R1, =0x00000011		;#
	STR		R1, [R0]


Init_DDR1600_3_5:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000003
	STR		R1, [R0]
Init_DDR1600_3_6:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x0300C561
	STR		R1, [R0]

Init_DDR1600_3_7:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000023
	STR		R1, [R0]
Init_DDR1600_3_8:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x00FCDB60
	STR		R1, [R0]

Init_DDR1600_3_9:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000011
	STR		R1, [R0]
Init_DDR1600_3_10:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x1000040B
	STR		R1, [R0]

Init_DDR1600_3_11:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000012
	STR		R1, [R0]
Init_DDR1600_3_12:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x9D9CBB66
	STR		R1, [R0]

Init_DDR1600_3_13:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000013
	STR		R1, [R0]
Init_DDR1600_3_14:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x1A868400
	STR		R1, [R0]

Init_DDR1600_3_15:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000014
	STR		R1, [R0]
Init_DDR1600_3_16:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x300214D8
	STR		R1, [R0]

Init_DDR1600_3_17:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000015
	STR		R1, [R0]
Init_DDR1600_3_18:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x00000D70		;#[31:16]=0 ,[15:0]=MR0
	STR		R1, [R0]

Init_DDR1600_3_19:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000016
	STR		R1, [R0]
Init_DDR1600_3_20:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x00000006
	STR		R1, [R0]

Init_DDR1600_3_21:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000017
	STR		R1, [R0]
Init_DDR1600_3_22:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x00000018		;#[31:16]=0 ,[15:0]=MR2
	STR		R1, [R0]

Init_DDR1600_3_23:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x0000001A
	STR		R1, [R0]
Init_DDR1600_3_24:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x910035C7
	STR		R1, [R0]

Init_DDR1600_3_25:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000004
	STR		R1, [R0]
Init_DDR1600_3_26_0:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1,	[R0]			;# R1 = Read Data
	TST		R1,	#0x00000001		;# Bit0"0"ǂ̔  [ R1 & H'1 -> 0̏ꍇ:Zeroflag=1 , 1̏ꍇ:Zeroflag=0 ]
	BEQ		Init_DDR1600_3_26_0	;# Bit0"0"(Z=1)̏ꍇ[v    [ BEQ [Z=1̎]   ,BNE [Z=0̎] ]


Init_DDR1600_3_27:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000001
	STR		R1, [R0]
Init_DDR1600_3_28:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x00000181
	STR		R1, [R0]


;#(3)-29	E蓮R}hsWX^iDBCMDjɂSDRAMCKE[qHighɂ܂B
Init_DDR1600_3_29:
	LDR		R0,	=DBSC3_0_DBCMD
	LDR		R1, =0x11000000		;# opc=PDXt
	STR		R1, [R0]

Init_DDR1600_3_30:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000004
	STR		R1, [R0]
Init_DDR1600_3_31_0:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1,	[R0]			;# R1 = Read Data
	TST		R1,	#0x00000001		;# Bit0"0"ǂ̔  [ R1 & H'1 -> 0̏ꍇ:Zeroflag=1 , 1̏ꍇ:Zeroflag=0 ]
	BEQ		Init_DDR1600_3_31_0	;# Bit0"0"(Z=1)̏ꍇ[v    [ BEQ [Z=1̎]   ,BNE [Z=0̎] ]


Init_DDR1600_3_32:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000001
	STR		R1, [R0]
Init_DDR1600_3_33:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0x0000FE01
	STR		R1, [R0]


;#(4)  (d)	DBSC Setting 2--------------------------------------------------------------------------
;#(4)-1	EoX䕔0ݒ背WX^1 (DBBS0CNT1)
Init_DDR1600_4_1:
	LDR		R0,	=DBSC3_0_DBBS0CNT1
	LDR		R1, =00000000		;#
	STR		R1, [R0]

;#(4)-2	EDDR3-SDRAMLu[Vݒ背WX^(DBCALCNF)
Init_DDR1600_4_2:
	LDR		R0,	=DBSC3_0_DBCALCNF
	LDR		R1, =0x01004C20		;#
	STR		R1, [R0]

;#(4)-3	EDDR3-SDRAMLu[V^C~OWX^(DBCALTR)
Init_DDR1600_4_3:
	LDR		R0,	=DBSC3_0_DBCALTR
;#	LDR		R1, =0x014000AA		;#
	LDR		R1, =0x014A00B9		;#Change Ver0.04 2015.02.12
	STR		R1, [R0]

;#(4)-4-@EtbVݒ背WX^0iDBRFCNF0j
Init_DDR1600_4_4_1:
	LDR		R0,	=DBSC3_0_DBRFCNF0
	LDR		R1, =0x00000140		;# 320Cycle
	STR		R1, [R0]

;#(4)-4-AEtbVݒ背WX^1iDBRFCNF1j
Init_DDR1600_4_4_2:
	LDR		R0,	=DBSC3_0_DBRFCNF1
	LDR		R1, =0x00081860		;# REFFPMAX=8,REFINT=6240Cycle 800MHz
	STR		R1, [R0]

;#(4)-4-BEtbVݒ背WX^2iDBRFCNF2j
Init_DDR1600_4_4_3:
	LDR		R0,	=DBSC3_0_DBRFCNF2
	LDR		R1, =0x00010000		;# REFINT = 1/1
	STR		R1, [R0]


Init_DDR1600_3_34:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000004
	STR		R1, [R0]
Init_DDR1600_3_35_0:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1,	[R0]			;# R1 = Read Data
	TST		R1,	#0x00000001		;# Bit0"0"ǂ̔  [ R1 & H'1 -> 0̏ꍇ:Zeroflag=1 , 1̏ꍇ:Zeroflag=0 ]
	BEQ		Init_DDR1600_3_35_0	;# Bit0"0"(Z=1)̏ꍇ[v    [ BEQ [Z=1̎]   ,BNE [Z=0̎] ]


;#(4)-5	EtbVWX^iDBRFENjARFENrbg1ɐݒ肵܂B
Init_DDR1600_4_5:
	LDR		R0,	=DBSC3_0_DBRFEN
	LDR		R1, =0x00000001		;# AREF=Enable
	STR		R1, [R0]


;# Add Ver0.03  2014.10.01
;# ------------------------
Init_DDR1600_4_5_ADD1:
	LDR		R0,	=DBSC3_0_DBPDRGA
	LDR		R1, =0x00000010
	STR		R1, [R0]
Init_DDR1600_4_5_ADD2:
	LDR		R0,	=DBSC3_0_DBPDRGD
	LDR		R1, =0xF00464DB
	STR		R1, [R0]
;# ------------------------

;# ########### Work around for bootlock error ############################################
;# Ver0.05
;#
	LDR		R0,	=DBSC3_0_DBRST
	LDR		R1, =0x00000000
	STR		R1, [R0]

	LDR		R0,	=DBSC3_0_DBRSTLCK
	LDR		R1, =0x00000000
	STR		R1, [R0]

;# ########################################################################################

;#(4)-6	ESDRAMANZXWX^iDBACENjACCENrbg1iANZXjɐݒ肵܂B
Init_DDR1600_4_6:
	LDR		R0,	=DBSC3_0_DBACEN
	LDR		R1, =0x00000001		;# ACCEN=Enable
	STR		R1, [R0]

Init_DDR1600_4_7:
	LDR		R0,	=DBSC3_0_DBPDLCK
	LDR		R1, =0x00000000
	STR		R1, [R0]


;# --------------------------------------------------------------------------------------------------
;####		END DDR1600(800MHz) setting	#########################################################
;# --------------------------------------------------------------------------------------------------
	B		Init_set_DDR_END

 .pool



Init_set_DDR_END:
;####	 end DDR Setting		####################################################################




;####################################################################################################
;####	C֐
;####################################################################################################
Jmp_MAIN_C:
	LDR		PC, =BootLoaderMain

;####################################################################################################
;####	prgStartAdɔ
;####################################################################################################
GoMain:



.IF CACHE_MODE == ENABLE
;####################################################################################################
;#####		Z:\AI:߃LbVLɐݒ
;####################################################################################################
;#Init_enable_Cache:  CP15  WX^P(C1)F䃌WX^
  MRC     p15, 0, r0, c1, c0, 0   ;# Read CP15 REG1(C1) data
  BIC     r0, r0, #(1 << 11)      ;# bit11:Z bit Set  (\          1:  0:֎~)
  BIC     r0, r0, #(1 << 12)      ;# bit12:I bit Set  (߃LbV    1:  0:֎~)
  MCR     p15, 0, r0, c1, c0, 0   ;# Write CP15 REG1(C1)data
  ISB                             ;# ߓ

;#invalidate                      ;#
  MCR     p15, 0, r0, c7, c5, 0   ;# ICIALLU :Invalidate all instruction caches to PoU
  MCR     p15, 0, r0, c7, c5, 6   ;# BPIALL  :Invalidate all branch predictors


.ENDIF



	LDR		R1, =prgStartAd		;#
	LDR		PC, [R1]			;#

	.END
